package de.jatitv.commandguiv2.Spigot.gui;

import com.mojang.authlib.GameProfile;
import com.mojang.authlib.properties.Property;
import de.jatitv.commandguiv2.Spigot.Main;
import de.jatitv.commandguiv2.Spigot.Objekte.Object;
import de.jatitv.commandguiv2.Spigot.Objekte.Slot;
import de.jatitv.commandguiv2.Spigot.config.config.SelectConfig;
import de.jatitv.commandguiv2.Util;
import net.t2code.lib.Spigot.Lib.items.ItemVersion;
import net.t2code.lib.Spigot.Lib.messages.send;
import net.t2code.lib.Spigot.Lib.minecraftVersion.MCVersion;
import net.t2code.lib.Spigot.Lib.replace.Replace;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.inventory.meta.SkullMeta;

import java.lang.reflect.Field;
import java.util.UUID;

public class GuiBuilder {

    private static String prefix = Util.getPrefix();

    protected static void item(Slot slot, Player player, Inventory inventory) {
        ItemStack item = new ItemStack(Material.valueOf(slot.item.toUpperCase().replace(".", "_")));
        ItemMeta itemMeta = item.getItemMeta();
        setDisplayNameAndLore(itemMeta, player, slot);
        item.setItemMeta(itemMeta);
        Integer am;
        if (slot.itemAmount == 0) {
            am = 1;
        } else am = slot.itemAmount;
        item.setAmount(am);
        inventory.setItem(slot.slot, item);
    }

    protected static void item(String material, Slot slot, Player player, Inventory inventory) {
        ItemStack item = new ItemStack(Material.valueOf(material));
        ItemMeta itemMeta = item.getItemMeta();
        setDisplayNameAndLore(itemMeta, player, slot);
        item.setItemMeta(itemMeta);
        Integer am;
        if (slot.itemAmount == 0) {
            am = 1;
        } else am = slot.itemAmount;
        item.setAmount(am);
        inventory.setItem(slot.slot, item);
    }


    private static void setDisplayNameAndLore(ItemMeta itemMeta, Player player, Slot slot) {
        if (Main.PaPi) {
            itemMeta.setDisplayName(Replace.replace(prefix, player, slot.name.replace("[player]", player.getName())));
            itemMeta.setLore(Replace.replacePrice(prefix, player, slot.lore, slot.price + " " + SelectConfig.Currency));
        } else {
            itemMeta.setDisplayName(Replace.replace(prefix, slot.name.replace("[player]", player.getName())));
            itemMeta.setLore(Replace.replacePrice(prefix, slot.lore, slot.price + " " + SelectConfig.Currency));
        }
    }

    protected static void base64(String base64Value, Slot slot, Player player, Inventory inventory) {
        ItemStack item = ItemVersion.getHeadIS();
        SkullMeta itemMeta = (SkullMeta) item.getItemMeta();
        setBase64(itemMeta, base64Value);
        setDisplayNameAndLore(itemMeta, player, slot);
        item.setItemMeta(itemMeta);
        Integer am;
        if (slot.itemAmount == 0) {
            am = 1;
        } else am = slot.itemAmount;
        item.setAmount(am);
        inventory.setItem(slot.slot, item);
    }

    private static void setBase64(ItemMeta itemMeta, String base64Value) {
        GameProfile profile = new GameProfile(UUID.randomUUID(), "");
        profile.getProperties().put("textures", new Property("textures", base64Value == null ? "" : base64Value));
        Field profileField;
        try {
            profileField = itemMeta.getClass().getDeclaredField("profile");
            profileField.setAccessible(true);
            profileField.set(itemMeta, profile);
        } catch (IllegalArgumentException | IllegalAccessException | NoSuchFieldException | SecurityException e) {
            e.printStackTrace();
        }
    }

    protected static void base64(Slot slot, Player player, Inventory inventory) {
        base64(slot.base64Value, slot, player, inventory);
    }

    protected static void playerHead(Slot slot, Player player, Inventory inventory, String skullName) {
        ItemStack item = ItemVersion.getHeadIS();
        SkullMeta itemMeta = (SkullMeta) item.getItemMeta();
        setDisplayNameAndLore(itemMeta, player, slot);
        itemMeta.setOwner(skullName);
        item.setItemMeta(itemMeta);
        Integer am;
        if (slot.itemAmount == 0) {
            am = 1;
        } else am = slot.itemAmount;
        item.setAmount(am);
        inventory.setItem(slot.slot, item);
    }

    public static void fillItem(Inventory inventory, Object gui) {
        ItemStack glass;
        if (MCVersion.minecraft1_8 || MCVersion.minecraft1_9 || MCVersion.minecraft1_10 || MCVersion.minecraft1_11 || MCVersion.minecraft1_12) {
            glass = new ItemStack(Material.valueOf("STAINED_GLASS_PANE"), 1, Short.valueOf(gui.GUI_FillItem_Item));
        } else glass = new ItemStack(Material.valueOf(gui.GUI_FillItem_Item.toUpperCase().replace(".", "_")));
        ItemMeta itemMetaglass = glass.getItemMeta();
        itemMetaglass.setDisplayName(" ");
        glass.setItemMeta(itemMetaglass);
        glass.setAmount(1);
        for (int i = 0; i < 9 * gui.GUI_Lines; i++) {
            inventory.setItem(i, glass);
        }
    }
}
